<template>
  <div class="tile is-ancestor">
    <div class="tile is-vertical is-parent">
      <div class="tile has-text-centered
                  is-block avatar">
        <img
          src="https://picsum.photos/600/400"
          alt="A random image"
        />
      </div>

      <div class="tile has-text-centered is-block">
        <!-- Trophies and Clan -->
        <user-trophies :trophies="trophies"/>
      </div>
    </div>
    <div class="tile is-vertical is-parent">
      <div class="tile tile-stars has-text-centered is-block">
        <!-- Stars and V1 -->
        <stars size="large"
               :stars="stars" />
        <b-tooltip :label="$t('user.completion')"
                   position="is-bottom">
          <b-progress class="mt-5"
                      type="is-primary"
                      :value="60"
                      show-value
                      format="percent" />
        </b-tooltip>
      </div>
        <!-- V1  -->
        <h2 class="is-size-4 is-capitalized">
          <b-icon icon="tachometer-alt" />
          {{ $t('ranking.v1_total') }}
        </h2>
        <p class="is-size-5" v-if="periodRank">
            <b-tooltip :label="$t('user.v1RankTooltip')"
                       _position="is-bottom">
              <router-link :to="{ name: 'V1Ranking' }"
                           class="has-text-green">
                <b-icon icon="list-ol" />
                {{ periodRank }}
              </router-link>
            </b-tooltip>
          </p>
        <b-progress :type="'is-' + v1ProgressColor"
                    :value="v1Total"
                    :max="18000"
                    size="is-large"
                    show-value />
      <div class="tile is-block">
        <!-- Scores -->
        <user-scores :loading="loading"
                     :scores="scores"
                     :feathersCount="feathersCount" />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import { Score, StarObject, Trophies } from '@/types/scores';
import Stars from '@/components/layout/sidebar/Stars.vue';
import UserTrophies from '@/components/users/UserTrophies.vue';
import UserScores from '@/components/users/UserScores.vue';

@Component({
  components: { Stars, UserScores, UserTrophies }
})
export default class UserScoresTab extends Vue {
  @Prop(Array) readonly scores: Score[];
  @Prop(Boolean) readonly loading: boolean;
  @Prop(Object) readonly stars: StarObject;
  @Prop(Number) readonly v1Total: number;
  @Prop(Number) readonly periodRank: number;
  @Prop(Object) readonly trophies: Trophies;
  @Prop(Number) readonly feathersCount: number;

  get v1ProgressColor(): string {
    const v1_total = this.v1Total;

    if (v1_total < 12000)
      return 'grey';
    else if (v1_total < 13200)
      return 'green';
    else if (v1_total < 13800)
      return 'orange';
    else if (v1_total < 18000)
      return 'red';

    return 'black';
  }
}
</script>
